## ginkgocadx 2.6.0.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
SUBDIRS(src)

=== src/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(BUILD_ALL)

SET(GINKGO_VERSION     2 CACHE STRING "Version number")
SET(GINKGO_SUB_VERSION 6 CACHE STRING "Subversion number")
SET(GINKGO_SUB_RELEASE 0 CACHE STRING "Release number")
SET(GINKGO_BUILD 0)
EXECUTE_PROCESS(
	COMMAND /bin/bash -c "grep BUILD ${CMAKE_SOURCE_DIR}/cadxcore/main/licencia.h | sed 's/[^\\:]*:[ \\t]*\\([^ \\t]*\\).*/\\1/' | xargs echo -n"
	OUTPUT_VARIABLE GINKGO_BUILD
)
SET(GINKGO_CODENAME    beta CACHE STRING "Codename tag")

SET( USE_PATCHED_LIBS        FALSE CACHE BOOL "Use patched libraries")
SET( BUILD_VISUALIZATION_EXT TRUE CACHE BOOL "Build Visualization extention")
SET( BUILD_OPHTALMOLOGY_EXT  FALSE CACHE BOOL "Build Ophtalmology extension")
SET( BUILD_DERMATHOLOGY_EXT  FALSE CACHE BOOL "Build Dermathology extension")
SET( BUILD_VIDEO_EXT         FALSE CACHE BOOL "Build Video extension")
SET( BUILD_LIGHT_VISUALIZATOR_EXT TRUE CACHE BOOL "Build Light Visualizator extension")
SET( BUILD_OCT_EXT           FALSE CACHE BOOL "Build OCT extension")
SET( BUILD_SCANNER_EXT		  FALSE CACHE BOOL "Build Scanner extension")
SET( BUILD_FOO_EXT           FALSE CACHE BOOL "Build Foo extension")

SET( USE_SYSTEM_SQLITE       TRUE CACHE BOOL "Build with system SQLite library")
SET( USE_CUSTOM_WX           FALSE CACHE BOOL "Build with custom WX library")
SET( USE_CUSTOM_VTK          FALSE CACHE BOOL "Build with custom VTK library")
SET( USE_CUSTOM_ITK          FALSE CACHE BOOL "Build with custom ITK library")
SET( USE_CUSTOM_DCMTK        FALSE CACHE BOOL "Build with custom DCMTK library")

SET( CUSTOM_PACKAGE          FALSE CACHE BOOL "Custom package")
SET( FORCE_SSE               FALSE CACHE BOOL "Force SSE Flag")
SET( INTERNET_DIST           TRUE CACHE BOOL "Public distribution")

SET( CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "MacOSX Architectures" FORCE)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


SET( GINKGO_VERSION_STR "${GINKGO_VERSION}.${GINKGO_SUB_VERSION}.${GINKGO_SUB_RELEASE}.${GINKGO_BUILD}")

#############################################################################################

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
INCLUDE(SysDefs)

#############################################################################################

IF(LINUX)
	FIND_PACKAGE(GTK2 REQUIRED)
ENDIF()

IF(USE_PATCHED_LIBS) 
	MESSAGE("Using patched libs")
ENDIF()

IF(NOT USE_CUSTOM_WX)
	MESSAGE("Using system wxWidgets")
	FIND_PACKAGE(wxWidgets 2.8.11 COMPONENTS core base gl net xml aui adv richtext xrc REQUIRED)
ELSE()
	MESSAGE("Using custom wxWidgets")
	SET_CUSTOM_wxWidgets_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_VTK)
	MESSAGE("Using system VTK")
	FIND_PACKAGE(VTK 5.6.1 REQUIRED)
ELSE()
	MESSAGE("Using custom VTK")
	SET_CUSTOM_VTK_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_ITK)
	MESSAGE("Using system ITK")
	FIND_PACKAGE(ITK REQUIRED)
ELSE()
	MESSAGE("Using custom ITK")
	SET_CUSTOM_ITK_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_DCMTK)
	MESSAGE("Using system DCMTK")
	FIND_PACKAGE(DCMTK 3.6.0 EXACT REQUIRED)
ELSE()
	MESSAGE("Using custom DCMTK")
	SET_CUSTOM_DCMTK_PACKAGE()
ENDIF()

IF(NOT USE_SYSTEM_SQLITE)
	MESSAGE("Using builtin SQLite")
ELSE()
	MESSAGE("Using system SQLite")
	#FIND_PACKAGE(sqlite REQUIRED)
	
ENDIF()

#############################################################################################

IF(MACOS)
	SET(GINKGO_PROJECT "Ginkgo CADx" CACHE PARENT_SCOPE "")
ELSEIF(LINUX AND CUSTOM_PACKAGE)
	SET(GINKGO_PROJECT "ginkgocadx-${ARCH}" CACHE PARENT_SCOPE "")
ELSE()
	SET(GINKGO_PROJECT "ginkgocadx" CACHE PARENT_SCOPE "")
ENDIF()

SET(GINKGO_PLUGINS "" CACHE PARENT_SCOPE "")

SUBDIRS( cadxcore ginkgocadx  )

IF (BUILD_OPHTALMOLOGY_EXT OR BUILD_DERMATHOLOGY_EXT OR BUILD_VIDEO_EXT OR BUILD_OCT_EXT OR BUILD_SCANNER_EXT)
	INCLUDE(PrvExtDeps)
ENDIF()

IF(BUILD_FOO_EXT)
	SUBDIRS(fooextension)
ENDIF()

IF(BUILD_OPHTALMOLOGY_EXT)
	SUBDIRS(oftalmologia)
ENDIF()

IF(BUILD_OCT_EXT)
	SUBDIRS(octextension)
ENDIF()

IF(BUILD_DERMATHOLOGY_EXT)
	SUBDIRS(dermatologia)
ENDIF()

IF(BUILD_VIDEO_EXT)
	SUBDIRS(gnkvideo)
ENDIF()

IF(BUILD_VISUALIZATION_EXT)
	SUBDIRS(visualizator)
ENDIF()

IF(BUILD_LIGHT_VISUALIZATOR_EXT)
	SUBDIRS(lightvisualizator)
ENDIF()

IF(BUILD_SCANNER_EXT)
	SUBDIRS(scannerextension)
ENDIF()

ADD_CUSTOM_TARGET(${PROJECT_NAME} echo)

MESSAGE("Building ${GINKGO_PROJECT} ${GINKGO_VERSION_STR}.${GINKGO_CODENAME}")

ADD_DEPENDENCIES(${PROJECT_NAME} "${GINKGO_PROJECT}")

IF(BUILD_FOO_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} fooextension)
	LIST(APPEND GINKGO_PLUGINS "fooextension")
ENDIF()

IF(BUILD_VISUALIZATION_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} visualizator)
	LIST(APPEND GINKGO_PLUGINS "visualizator")
ENDIF()

IF(BUILD_OPHTALMOLOGY_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} oftalmologia)
	LIST(APPEND GINKGO_PLUGINS "oftalmologia")
ENDIF()

IF(BUILD_OCT_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} octextension)
	LIST(APPEND GINKGO_PLUGINS "octextension")
ENDIF()

IF(BUILD_DERMATHOLOGY_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} dermatologia)
	LIST(APPEND GINKGO_PLUGINS "dermatologia")
ENDIF()

IF(BUILD_VIDEO_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} gnkvideo)
	LIST(APPEND GINKGO_PLUGINS "gnkvideo")
ENDIF()

IF(BUILD_LIGHT_VISUALIZATOR_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} lightvisualizator)
	LIST(APPEND GINKGO_PLUGINS "lightvisualizator")
ENDIF()

IF(BUILD_SCANNER_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} scannerextension)
	LIST(APPEND GINKGO_PLUGINS "scannerextension")
ENDIF()

IF(CUSTOM_PACKAGE)

SET( DEST "${CMAKE_CURRENT_BINARY_DIR}/dist" )
PACKAGE_RULES( "${PROJECT_NAME}" "${ARCH}" "${DEST}" )
ENDIF()

=== src/cadxcore/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(CADxCore)

################ SOURCES ################

AUX_SOURCE_DIRECTORY(api SRCS)
AUX_SOURCE_DIRECTORY(api/controllers SRCS)
AUX_SOURCE_DIRECTORY(api/helpers SRCS)
AUX_SOURCE_DIRECTORY(api/math SRCS)
AUX_SOURCE_DIRECTORY(api/observers SRCS)
AUX_SOURCE_DIRECTORY(api/dicom SRCS)
AUX_SOURCE_DIRECTORY(api/threads SRCS)
AUX_SOURCE_DIRECTORY(api/internacionalization SRCS)

AUX_SOURCE_DIRECTORY(main SRCS)
AUX_SOURCE_DIRECTORY(main/controllers SRCS)
AUX_SOURCE_DIRECTORY(main/filtering SRCS)
AUX_SOURCE_DIRECTORY(main/gui SRCS)
AUX_SOURCE_DIRECTORY(main/gui/acquisition SRCS)
AUX_SOURCE_DIRECTORY(main/gui/callibration SRCS)
AUX_SOURCE_DIRECTORY(main/gui/configuration SRCS)
AUX_SOURCE_DIRECTORY(main/gui/countdownmessage SRCS)
AUX_SOURCE_DIRECTORY(main/gui/dicomeditor SRCS)
AUX_SOURCE_DIRECTORY(main/gui/dicomdirexport SRCS)
AUX_SOURCE_DIRECTORY(main/gui/export SRCS)
AUX_SOURCE_DIRECTORY(main/gui/history SRCS)
AUX_SOURCE_DIRECTORY(main/gui/hl7controlwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/import SRCS)
AUX_SOURCE_DIRECTORY(main/gui/license SRCS)
AUX_SOURCE_DIRECTORY(main/gui/logcontrolwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/login SRCS)
AUX_SOURCE_DIRECTORY(main/gui/mainwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/open SRCS)
AUX_SOURCE_DIRECTORY(main/gui/pacsupload SRCS)
AUX_SOURCE_DIRECTORY(main/gui/paneltags SRCS)
AUX_SOURCE_DIRECTORY(main/gui/print SRCS)
AUX_SOURCE_DIRECTORY(main/gui/progress SRCS)
AUX_SOURCE_DIRECTORY(main/gui/startup SRCS)
AUX_SOURCE_DIRECTORY(main/gui/tabtoolbar SRCS)
AUX_SOURCE_DIRECTORY(main/managers SRCS)
AUX_SOURCE_DIRECTORY(main/tools SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/libi2d SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/ofstd SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/tls SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/tls/win-only SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/log4cplus SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/streaming SRCS)

AUX_SOURCE_DIRECTORY(commands SRCS)

AUX_SOURCE_DIRECTORY(net SRCS)

AUX_SOURCE_DIRECTORY(resources SRCS)

IF(NOT USE_SYSTEM_SQLITE)
AUX_SOURCE_DIRECTORY(sqlite SRCS)
ENDIF()

AUX_SOURCE_DIRECTORY(endpoint SRCS)

AUX_SOURCE_DIRECTORY(vtk SRCS)
AUX_SOURCE_DIRECTORY(vtk/command SRCS)
AUX_SOURCE_DIRECTORY(vtk/interactor SRCS)
AUX_SOURCE_DIRECTORY(vtk/widgets SRCS)

AUX_SOURCE_DIRECTORY(widgets SRCS)
AUX_SOURCE_DIRECTORY(widgets/gui SRCS)
AUX_SOURCE_DIRECTORY(widgets/observers SRCS)

AUX_SOURCE_DIRECTORY(wx SRCS)
AUX_SOURCE_DIRECTORY(wx/ginkgostyle SRCS)
AUX_SOURCE_DIRECTORY(wx/gnkinforme SRCS)
AUX_SOURCE_DIRECTORY(wx/iconoimagenctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/maskedtextctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/propgrid SRCS)
AUX_SOURCE_DIRECTORY(wx/propiedades SRCS)
AUX_SOURCE_DIRECTORY(wx/thumbnailctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/timectrl SRCS)
AUX_SOURCE_DIRECTORY(wx/treelistctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/VTK SRCS)
AUX_SOURCE_DIRECTORY(wx/wizardginkgo SRCS)
AUX_SOURCE_DIRECTORY(wx/wxsqlite3 SRCS)
AUX_SOURCE_DIRECTORY(wx/wxhttpengine SRCS)

AUX_SOURCE_DIRECTORY(VTKInria3D SRCS)
AUX_SOURCE_DIRECTORY(VTKInria3D/vtkVISUManagement SRCS)
AUX_SOURCE_DIRECTORY(VTKInria3D/wxVTK SRCS)

AUX_SOURCE_DIRECTORY(resources SRCS)

IF (LINUX OR MACOS)
	AUX_SOURCE_DIRECTORY(xmlrpc SRCS)
ENDIF()

IF (LINUX OR MACOS)
	LIST(REMOVE_ITEM SRCS endpoint/interfaces.cpp)
	LIST(REMOVE_ITEM SRCS endpoint/sockatmark.cpp)
ELSEIF(WINDOWS)
	SET(SRCS stdafx.cpp ${SRCS})
ENDIF()

################ DEFINITIONS ################

ADD_CORE_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/vtk
	${CMAKE_CURRENT_SOURCE_DIR}/itk
	${CMAKE_CURRENT_SOURCE_DIR}/wx
	${CMAKE_CURRENT_SOURCE_DIR}/wx/VTK
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D/wxVTK
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D/vtkRenderingAddons
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${PROJECT_NAME} ${${PROJECT_NAME}_INCLUDE_DIR} )

################ LIBS ################

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()

IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

IF(USE_CUSTOM_DCMTK)
	ADD_DEFINITIONS(${DCMTK_defines})
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${DCMTK_DIR})
ELSE()
	ADD_DEFINITIONS(-DHAVE_CONFIG_H)
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIRS})
	#MESSAGE("DCMTKLIBS = ${DCMTK_LIBRARIES}")
	#MESSAGE("DCMTKINC = ${DCMTK_INCLUDE_DIRS}")
ENDIF()

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})

IF (MACOS)
	ADD_DEFINITIONS(${XmlRpc++_defines})
	INCLUDE_DIRECTORIES(${XmlRpc++_INCLUDE_DIR})
	LINK_DIRECTORIES(${XmlRpc++_DIR})
ENDIF()

IF (LINUX)
	IF (GTK2_FOUND)
	  INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
	ELSE ()
	  MESSAGE("-----------------GTK2 NOT FOUND--------------------")
	  INCLUDE_DIRECTORIES(/usr/include/gtk-2.0
	      /usr/include/atk-1.0
	      /usr/include/pango-1.0
	      /usr/include/gio-unix-2.0/
	      /usr/include/glib-2.0
	      /usr/lib/i386-linux-gnu/glib-2.0/include
	      /usr/include/freetype2
	      /usr/include/libpng12
	      /usr/lib/gtk-2.0/include
	      /usr/include/cairo
	      /usr/include/gdk-pixbuf-2.0
	      /usr/include/pixman-1
	  )  
	ENDIF ()
ENDIF()


################ TARGET ################

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION_STR}" SOVERSION "${GINKGO_VERSION_STR}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH FALSE )
INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/ginkgocadx)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/es/ginkgocadxcore.mo DESTINATION share/ginkgocadx/lang/es)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/ja/ginkgocadxcore.mo DESTINATION share/ginkgocadx/lang/ja)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/de/ginkgocadxcore.mo DESTINATION share/ginkgocadx/lang/de)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/tr/ginkgocadxcore.mo DESTINATION share/ginkgocadx/lang/tr)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/resources/conformance.xml DESTINATION share/ginkgocadx)
################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})

IF(USE_CUSTOM_DCMTK)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${DCMTK_LIBRARIES})
ELSE()
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${DCMTK_LIBRARIES} wrap)
ENDIF()

IF(USE_SYSTEM_SQLITE)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} sqlite3)
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (MACOS)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${XmlRpc++_LIBRARIES})
ENDIF()

IF(LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${GTK2_LIBRARIES})
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ssl GL crypto xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS ssl crypto xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/fooextension/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(fooextension)

################ SOURCES ################

SET(SRCS fooextension.cpp)
AUX_SOURCE_DIRECTORY(fooextension/commands SRCS)
AUX_SOURCE_DIRECTORY(fooextension/controllers SRCS)
AUX_SOURCE_DIRECTORY(fooextension/gui SRCS)
AUX_SOURCE_DIRECTORY(fooextension/gui/importation SRCS)
AUX_SOURCE_DIRECTORY(fooextension/studies SRCS)
AUX_SOURCE_DIRECTORY(fooextension/views SRCS)
AUX_SOURCE_DIRECTORY(fooextension/wxvtk SRCS)

################ DEFINITIONS ################

ADD_EXTENSION_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

INCLUDE_DIRECTORIES(${${PROJECT_NAME}_INCLUDE_DIR})

IF(USE_CUSTOM_WX)
   ADD_DEFINITIONS(${wxWidgets_defines})
   INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
   LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
   INCLUDE(${wxWidgets_USE_FILE})
   #MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()


IF (USE_CUSTOM_VTK)
   ADD_DEFINITIONS(${VTK_defines})
   INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
   LINK_DIRECTORIES(${VTK_DIR})
ELSE()
   INCLUDE(${VTK_USE_FILE})
   SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
   vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
   #MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

IF(USE_CUSTOM_ITK)
   ADD_DEFINITIONS(${ITK_defines})
   INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
   LINK_DIRECTORIES(${ITK_DIR})
ELSE()
   INCLUDE(${ITK_USE_FILE})
   #MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})

################ TARGET ################

IF(LINUX AND NOT CUSTOM_PACKAGE)
   SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
   SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
   LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx" isSystemDir)
   IF("${isSystemDir}" STREQUAL "-1")
      SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
   ENDIF()
ENDIF()

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})

IF(LINUX)
	SET(LIBNAME "lib${PROJECT_NAME}.so.${GINKGO_VERSION_STR}")
ENDIF()
IF(MACOS)
	SET(LIBNAME "lib${PROJECT_NAME}.${GINKGO_VERSION_STR}.dylib")
ENDIF()

ADD_CUSTOM_COMMAND( TARGET ${PROJECT_NAME} POST_BUILD COMMAND /bin/sh ARGS "${CMAKE_CURRENT_SOURCE_DIR}/../ginkgocadx/build_descriptor.sh" "${CMAKE_CURRENT_SOURCE_DIR}" "${LIBNAME}" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf" "${GINKGO_VERSION}" "${GINKGO_SUB_VERSION}")

SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
   VERSION "${GINKGO_VERSION_STR}" SOVERSION "${GINKGO_VERSION_STR}"
   LINK_INTERFACE_LIBRARIES ""
   INSTALL_RPATH_USE_LINK_PATH TRUE )

INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/ginkgocadx/Plugins)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf DESTINATION lib/ginkgocadx/Plugins)

################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (LINUX)
   TARGET_LINK_LIBRARIES(${PROJECT_NAME} GL xml2)
ENDIF()

IF(MACOS)
   FIND_LIBRARY( CARBON_LIB Carbon )
   FIND_LIBRARY( OPENGL_LIB OpenGL )

   MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

   SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
   LIST( APPEND LIBS xml2 z )

   TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

   SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )

ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/ginkgocadx/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(${GINKGO_PROJECT})

SET(SRCS main.cpp)

ADD_GINKGO_DEFINITIONS()

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

IF(LINUX AND NOT CUSTOM_BUILD)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	ENDIF()
ENDIF()

IF(USE_CUSTOM_WX)
        ADD_DEFINITIONS(${wxWidgets_defines})
        INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
        LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
        INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("SYSTEM_WX: VL = ${VTK_DIR}")
        LINK_DIRECTORIES(${wxWidgets_DIR})
ENDIF()

IF (USE_CUSTOM_VTK)
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	#MESSAGE("SYSTEM_VTK: VL = ${VTK_DIR}")
	LINK_DIRECTORIES(${VTK_LIBRARY_DIRS})
ENDIF()


IF(USE_CUSTOM_ITK)
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	#MESSAGE("SYSTEM_ITK: IL = ${ITK_DIR}")
	LINK_DIRECTORIES(${ITK_DIR})
ENDIF()

IF(USE_CUSTOM_DCMTK)
	ADD_DEFINITIONS(${DCMTK_defines})
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${DCMTK_DIR})
ELSE()
	ADD_DEFINITIONS(-DHAVE_CONFIG_H)
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIRS})
	#MESSAGE("DCMTKLIBS = ${DCMTK_LIBRARIES}")
	#MESSAGE("DCMTKINC = ${DCMTK_INCLUDE_DIRS}")
ENDIF()

LINK_DIRECTORIES(${Cairo_DIR})
LINK_DIRECTORIES(${Pixman_DIR})
#LINK_DIRECTORIES(${XmlRpc++_DIR})

IF(MACOS)
	SET(SRCS ${SRCS}
		${CMAKE_CURRENT_SOURCE_DIR}/ginkgocadx.icns
		${CMAKE_CURRENT_SOURCE_DIR}/dcmdoc.icns
		${CMAKE_CURRENT_SOURCE_DIR}/../cadxcore/resources/conformance.xml
	)
	FOREACH(PLUGIN ${GINKGO_PLUGINS})
		EXECUTE_PROCESS(
			COMMAND /bin/bash -c "touch ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN}/${PLUGIN}.inf"
		)
		SET(SRCS ${SRCS} ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN}/${PLUGIN}.inf)
		SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN}/${PLUGIN}.inf PROPERTIES MACOSX_PACKAGE_LOCATION PlugIns)
	ENDFOREACH()
	
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/ginkgocadx.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/dcmdoc.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/../cadxcore/resources/conformance.xml PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/PkgInfo PROPERTIES MACOSX_PACKAGE_LOCATION .)
	LINK_LIBRARIES(CADxCore)
ENDIF()

ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})

IF(LINUX)
  TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)
ENDIF()

IF(USE_CUSTOM_DCMTK)
	MESSAGE("DCMTK_LIBS= ${DCMTK_LIBRARIES}" )
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${DCMTK_LIBRARIES})
ELSE()
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${DCMTK_LIBRARIES} oflog dcmdsig dcmtls wrap)
ENDIF()
IF(LINUX)
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	LINK_INTERFACE_LIBRARIES ""
	CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")

	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION bin)
ENDIF()

IF (MACOS)
	SET(DIRS
		$ {wxWidgets_DIR}
		${VTK_DIR}
		${ITK_DIR}
		${DCMTK_DIR}
		CADxCore
		${CMAKE_CURRENT_BINARY_DIR}/../cadxcore
	)
	MESSAGE("Directories: ${DIRS}")
	SET(GINKGO_PLUGINS "" CACHE PARENT_SCOPE "")

	SET(APPBUNDLE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app)
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "com.metaemotion.Ginkgo_CADx")
	SET(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
	SET(MACOSX_BUNDLE_VERSION ${GINKGO_VERSION_STR})
	
	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/GinkgoCADx-Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)

	SET(LIBS)

	MESSAGE("PLUGINS = ${GINKGO_PLUGINS}")
	FOREACH(PLUGIN ${GINKGO_PLUGINS})
		LIST(APPEND LIBS ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN}/lib${PLUGIN}.dylib)
	ENDFOREACH()

	install(CODE 
	        " 
	        include(BundleUtilities) 
	        fixup_bundle(\"${APPBUNDLE}\" \"${LIBS}\" \"${DIRS}\") 
	        " 
	        COMPONENT Runtime 
	    )
		
	SET_TARGET_PROPERTIES(
		"${PROJECT_NAME}"
		PROPERTIES
			MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist
		    LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}"
	)
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/lightvisualizator/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(lightvisualizator)

################ SOURCES ################

SET(SRCS lightvisualizatorextension.cpp)
AUX_SOURCE_DIRECTORY(lightvisualizator/controllers SRCS)
AUX_SOURCE_DIRECTORY(lightvisualizator/studies SRCS)
AUX_SOURCE_DIRECTORY(lightvisualizator/tools SRCS)
AUX_SOURCE_DIRECTORY(lightvisualizator/views SRCS)
AUX_SOURCE_DIRECTORY(lightvisualizator/wxvtk SRCS)

################ DEFINITIONS ################

ADD_EXTENSION_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

INCLUDE_DIRECTORIES(${${PROJECT_NAME}_INCLUDE_DIR})

################ TARGET ################

IF(LINUX AND NOT CUSTOM_PACKAGE)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	ENDIF()
ENDIF()

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()

IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})

IF(LINUX)
	SET(LIBNAME "lib${PROJECT_NAME}.so.${GINKGO_VERSION_STR}")
ENDIF()
IF(MACOS)
	SET(LIBNAME "lib${PROJECT_NAME}.${GINKGO_VERSION_STR}.dylib")
ENDIF()

ADD_CUSTOM_COMMAND( TARGET ${PROJECT_NAME} POST_BUILD COMMAND /bin/sh ARGS "${CMAKE_CURRENT_SOURCE_DIR}/../ginkgocadx/build_descriptor.sh" "${CMAKE_CURRENT_SOURCE_DIR}" "${LIBNAME}" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf" "${GINKGO_VERSION}" "${GINKGO_SUB_VERSION}")

SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION_STR}" SOVERSION "${GINKGO_VERSION_STR}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH FALSE )

INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/ginkgocadx/Plugins)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf DESTINATION lib/ginkgocadx/Plugins)

################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} GL xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/visualizator/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(visualizator)

################ SOURCES ################

SET(SRCS visualizator.cpp)
AUX_SOURCE_DIRECTORY(visualizator/comandos SRCS)
AUX_SOURCE_DIRECTORY(visualizator/controllers SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos/importacion SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos/seleccionardiagnostico SRCS)
AUX_SOURCE_DIRECTORY(visualizator/estudios SRCS)
AUX_SOURCE_DIRECTORY(visualizator/herramientas SRCS)
AUX_SOURCE_DIRECTORY(visualizator/vistas SRCS)
AUX_SOURCE_DIRECTORY(visualizator/widgets SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/commands SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/interactors SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/pipelines SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/volumedataset SRCS)
AUX_SOURCE_DIRECTORY(visualizator/resources SRCS)

################ DEFINITIONS ################

ADD_EXTENSION_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/comandos
	${CMAKE_CURRENT_SOURCE_DIR}/controllers
	${CMAKE_CURRENT_SOURCE_DIR}/dialogos
	${CMAKE_CURRENT_SOURCE_DIR}/estudios
	${CMAKE_CURRENT_SOURCE_DIR}/eventos
	${CMAKE_CURRENT_SOURCE_DIR}/exportacion
	${CMAKE_CURRENT_SOURCE_DIR}/herramientas
	${CMAKE_CURRENT_SOURCE_DIR}/vistas
	${CMAKE_CURRENT_SOURCE_DIR}/widgets
	${CMAKE_CURRENT_SOURCE_DIR}/wxvtk
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

INCLUDE_DIRECTORIES(${${PROJECT_NAME}_INCLUDE_DIR})

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()


IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()



IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})

################ TARGET ################

IF(LINUX AND NOT CUSTOM_PACKAGE)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/ginkgocadx")
	ENDIF()
ENDIF()

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})

IF(LINUX)
	SET(LIBNAME "lib${PROJECT_NAME}.so.${GINKGO_VERSION_STR}")
ENDIF()
IF(MACOS)
	SET(LIBNAME "lib${PROJECT_NAME}.${GINKGO_VERSION_STR}.dylib")
ENDIF()

ADD_CUSTOM_COMMAND( TARGET ${PROJECT_NAME} POST_BUILD COMMAND /bin/sh ARGS "${CMAKE_CURRENT_SOURCE_DIR}/../ginkgocadx/build_descriptor.sh" "${CMAKE_CURRENT_SOURCE_DIR}" "${LIBNAME}" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf" "${GINKGO_VERSION}" "${GINKGO_SUB_VERSION}")

SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION_STR}" SOVERSION "${GINKGO_VERSION_STR}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH FALSE )

INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/ginkgocadx/Plugins)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.inf DESTINATION lib/ginkgocadx/Plugins)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/es/visualizator.mo DESTINATION share/ginkgocadx/lang/es)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/ja/visualizator.mo DESTINATION share/ginkgocadx/lang/ja)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/de/visualizator.mo DESTINATION share/ginkgocadx/lang/de)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/tr/visualizator.mo DESTINATION share/ginkgocadx/lang/tr)

################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)


TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} GL xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== debian/changelog ===
ginkgocadx (2.6.0.0-1ubuntu1) precise; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - Link with xml2 library, needed by dcmtk, see
      http://bugs.debian.org/510120

 -- Andreas Moog <amoog@ubuntu.com>  Sat, 31 Dec 2011 16:57:34 +0100

ginkgocadx (2.6.0.0-1) unstable; urgency=low

  * New upstream version (refreshed patches)
  * debian/copyright: Added Upstream-Contact
  * debian/control: * s/libmysqlclient16/libmysqlclient-dev/ in
    Build-Deps (Thanks for the patch to Micah Gersten <micahg@ubuntu.com>)
    Closes: #652529

 -- Andreas Tille <tille@debian.org>  Sun, 18 Dec 2011 16:00:58 +0100

ginkgocadx (2.6.0.0~rc-2) unstable; urgency=low

  * removed hardcoded vtk version number - allow to link against vtk-5.8

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 11 Nov 2011 21:33:50 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for Ginkgo CADx

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake --parallel

pkg=ginkgocadx

DEB_CMAKE_EXTRA_FLAGS += \
	-DCMAKE_BUILD_TYPE:STRING=RELEASE

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS) 

override_dh_auto_install:
	dh_auto_install
	# Hack around useless rpath definitions
	/usr/bin/chrpath -r /usr/lib/ginkgocadx debian/$(pkg)/usr/bin/$(pkg)

get-orig-source:
	uscan --verbose --force-download --repack

## ginkgocadx 2.8.0.4602

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,14 +3,14 @@
 PROJECT(BUILD_ALL)
 
 SET(GINKGO_VERSION     2 CACHE STRING "Version number")
-SET(GINKGO_SUB_VERSION 6 CACHE STRING "Subversion number")
+SET(GINKGO_SUB_VERSION 8 CACHE STRING "Subversion number")
 SET(GINKGO_SUB_RELEASE 0 CACHE STRING "Release number")
 SET(GINKGO_BUILD 0)
 EXECUTE_PROCESS(
-	COMMAND /bin/bash -c "grep BUILD ${CMAKE_SOURCE_DIR}/cadxcore/main/licencia.h | sed 's/[^\\:]*:[ \\t]*\\([^ \\t]*\\).*/\\1/' | xargs echo -n"
+	COMMAND /bin/bash -c "grep BUILD ${CMAKE_SOURCE_DIR}/src/cadxcore/main/licencia.h | sed 's/[^\\:]*:[ \\t]*\\([^ \\t]*\\).*/\\1/' | xargs echo -n"
 	OUTPUT_VARIABLE GINKGO_BUILD
 )
-SET(GINKGO_CODENAME    beta CACHE STRING "Codename tag")
+SET(GINKGO_CODENAME    final CACHE STRING "Codename tag")
 
 SET( USE_PATCHED_LIBS        FALSE CACHE BOOL "Use patched libraries")
 SET( BUILD_VISUALIZATION_EXT TRUE CACHE BOOL "Build Visualization extention")
@@ -68,7 +68,7 @@
 
 IF(NOT USE_CUSTOM_VTK)
 	MESSAGE("Using system VTK")
-	FIND_PACKAGE(VTK 5.6.1 REQUIRED)
+	FIND_PACKAGE(VTK REQUIRED)
 ELSE()
 	MESSAGE("Using custom VTK")
 	SET_CUSTOM_VTK_PACKAGE()

=== debian/changelog ===
ginkgocadx (2.8.0.4602-1) unstable; urgency=low

  * New upstream version (adapted patch, removed patch applied upstream)
    Closes: #657827

 -- Andreas Tille <tille@debian.org>  Sun, 29 Jan 2012 12:02:54 +0100

=== debian/control ===
Source: ginkgocadx
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Thorsten Alteholz <debian@alteholz.de>, Mathieu Malaterre <mathieu.malaterre@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), cmake (>= 2.8), libgtk2.0-dev, libxml2-dev, libssl-dev, libwrap0-dev,
 libwxgtk2.8-dev (>= 2.8.10), libvtk5-dev (>= 5.6.0), libinsighttoolkit3-dev (>= 3.20.0),
 libdcmtk2-dev (>= 3.6.0), libcairo2-dev (>= 1.8.10), 
 libgdcm2-dev, libwrap0, libfftw3-dev, chrpath, libsqlite3-dev,
 libmysqlclient-dev (>= 5.1.57)
Standards-Version: 3.9.2
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/ginkgocadx/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/ginkgocadx/trunk/
Homepage: http://ginkgo-cadx.com/

Package: ginkgocadx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Medical Imaging Software and complete DICOM Viewer
 Ginkgo CADx provides a complete DICOM viewer solution with advanced
 capabilities and support for extensions.
 .
  * Easy and customizable interface through profiles.
  * Full featured DICOM image visualization.
  * Complete tool set (measure, markers, text, ...).
  * Multiple modalities support (Neurological, Radiological, Dermatological,
    Ophthalmological, Ultrasound, Endoscopy, ...)
  * Dicomization support from JPEG, PNG, GIF and TIFF.
  * Full EMH integration support: HL7 standard and IHE compliant workflows.
  * PACS Workstation (C-FIND, C-MOVE, C-STORE...)
  * Extensible through custom extensions.
    - Retinal image mosaic composition.
    - Automatic retinal analysis diagnostics.
    - Psoriasis automatic diagnostics.

## ginkgocadx 2.12.0.4889

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,9 @@
 PROJECT(BUILD_ALL)
 
 SET(GINKGO_VERSION     2 CACHE STRING "Version number")
-SET(GINKGO_SUB_VERSION 8 CACHE STRING "Subversion number")
+SET(GINKGO_SUB_VERSION 12 CACHE STRING "Subversion number")
 SET(GINKGO_SUB_RELEASE 0 CACHE STRING "Release number")
-SET(GINKGO_BUILD 0)
+SET(GINKGO_BUILD 4889)
 EXECUTE_PROCESS(
 	COMMAND /bin/bash -c "grep BUILD ${CMAKE_SOURCE_DIR}/src/cadxcore/main/licencia.h | sed 's/[^\\:]*:[ \\t]*\\([^ \\t]*\\).*/\\1/' | xargs echo -n"
 	OUTPUT_VARIABLE GINKGO_BUILD
@@ -16,10 +16,8 @@
 SET( BUILD_VISUALIZATION_EXT TRUE CACHE BOOL "Build Visualization extention")
 SET( BUILD_OPHTALMOLOGY_EXT  FALSE CACHE BOOL "Build Ophtalmology extension")
 SET( BUILD_DERMATHOLOGY_EXT  FALSE CACHE BOOL "Build Dermathology extension")
-SET( BUILD_VIDEO_EXT         FALSE CACHE BOOL "Build Video extension")
+SET( BUILD_DICOMIZERPRO_EXT  FALSE CACHE BOOL "Build Dicomizer Pro extension")
 SET( BUILD_LIGHT_VISUALIZATOR_EXT TRUE CACHE BOOL "Build Light Visualizator extension")
-SET( BUILD_OCT_EXT           FALSE CACHE BOOL "Build OCT extension")
-SET( BUILD_SCANNER_EXT		  FALSE CACHE BOOL "Build Scanner extension")
 SET( BUILD_FOO_EXT           FALSE CACHE BOOL "Build Foo extension")
 
 SET( USE_SYSTEM_SQLITE       TRUE CACHE BOOL "Build with system SQLite library")
@@ -112,28 +110,20 @@
 
 SUBDIRS( cadxcore ginkgocadx  )
 
-IF (BUILD_OPHTALMOLOGY_EXT OR BUILD_DERMATHOLOGY_EXT OR BUILD_VIDEO_EXT OR BUILD_OCT_EXT OR BUILD_SCANNER_EXT)
+IF (BUILD_OPHTALMOLOGY_EXT OR BUILD_DERMATHOLOGY_EXT OR BUILD_PRO_EXT)
 	INCLUDE(PrvExtDeps)
-ENDIF()
-
-IF(BUILD_FOO_EXT)
-	SUBDIRS(fooextension)
 ENDIF()
 
 IF(BUILD_OPHTALMOLOGY_EXT)
 	SUBDIRS(oftalmologia)
 ENDIF()
 
-IF(BUILD_OCT_EXT)
-	SUBDIRS(octextension)
-ENDIF()
-
 IF(BUILD_DERMATHOLOGY_EXT)
 	SUBDIRS(dermatologia)
 ENDIF()
 
-IF(BUILD_VIDEO_EXT)
-	SUBDIRS(gnkvideo)
+IF(BUILD_DICOMIZERPRO_EXT)
+	SUBDIRS(dicomizerpro)
 ENDIF()
 
 IF(BUILD_VISUALIZATION_EXT)
@@ -144,8 +134,8 @@
 	SUBDIRS(lightvisualizator)
 ENDIF()
 
-IF(BUILD_SCANNER_EXT)
-	SUBDIRS(scannerextension)
+IF(BUILD_FOO_EXT)
+	SUBDIRS(fooextension)
 ENDIF()
 
 ADD_CUSTOM_TARGET(${PROJECT_NAME} echo)
@@ -169,29 +159,19 @@
 	LIST(APPEND GINKGO_PLUGINS "oftalmologia")
 ENDIF()
 
-IF(BUILD_OCT_EXT)
-	ADD_DEPENDENCIES(${PROJECT_NAME} octextension)
-	LIST(APPEND GINKGO_PLUGINS "octextension")
-ENDIF()
-
 IF(BUILD_DERMATHOLOGY_EXT)
 	ADD_DEPENDENCIES(${PROJECT_NAME} dermatologia)
 	LIST(APPEND GINKGO_PLUGINS "dermatologia")
 ENDIF()
 
-IF(BUILD_VIDEO_EXT)
-	ADD_DEPENDENCIES(${PROJECT_NAME} gnkvideo)
-	LIST(APPEND GINKGO_PLUGINS "gnkvideo")
+IF(BUILD_DICOMIZERPRO_EXT)
+	ADD_DEPENDENCIES(${PROJECT_NAME} dicomizerpro)
+	LIST(APPEND GINKGO_PLUGINS "dicomizerpro")
 ENDIF()
 
 IF(BUILD_LIGHT_VISUALIZATOR_EXT)
 	ADD_DEPENDENCIES(${PROJECT_NAME} lightvisualizator)
 	LIST(APPEND GINKGO_PLUGINS "lightvisualizator")
-ENDIF()
-
-IF(BUILD_SCANNER_EXT)
-	ADD_DEPENDENCIES(${PROJECT_NAME} scannerextension)
-	LIST(APPEND GINKGO_PLUGINS "scannerextension")
 ENDIF()
 
 IF(CUSTOM_PACKAGE)

=== src/cadxcore/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,7 @@
 AUX_SOURCE_DIRECTORY(main/gui/pacsupload SRCS)
 AUX_SOURCE_DIRECTORY(main/gui/paneltags SRCS)
 AUX_SOURCE_DIRECTORY(main/gui/print SRCS)
+AUX_SOURCE_DIRECTORY(main/gui/dicomprint SRCS)
 AUX_SOURCE_DIRECTORY(main/gui/progress SRCS)
 AUX_SOURCE_DIRECTORY(main/gui/startup SRCS)
 AUX_SOURCE_DIRECTORY(main/gui/tabtoolbar SRCS)

=== src/visualizator/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 ################ SOURCES ################
 
 SET(SRCS visualizator.cpp)
-AUX_SOURCE_DIRECTORY(visualizator/comandos SRCS)
+AUX_SOURCE_DIRECTORY(visualizator/commands SRCS)
 AUX_SOURCE_DIRECTORY(visualizator/controllers SRCS)
 AUX_SOURCE_DIRECTORY(visualizator/dialogos SRCS)
 AUX_SOURCE_DIRECTORY(visualizator/dialogos/importacion SRCS)

=== debian/changelog ===
ginkgocadx (2.12.0.4889-1) unstable; urgency=low

  * New upstream version
  * debian/control: Standards-Version: 3.9.3 (no changes needed)
  * debhelper 9 (control+compat)

 -- Andreas Tille <tille@debian.org>  Sat, 19 May 2012 11:37:14 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>, Thorsten Alteholz <debian@alteholz.de>, Mathieu Malaterre <mathieu.malaterre@gmail.com>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8), cmake (>= 2.8), libgtk2.0-dev, libxml2-dev, libssl-dev, libwrap0-dev,
+Build-Depends: debhelper (>= 9), cmake (>= 2.8), libgtk2.0-dev, libxml2-dev, libssl-dev, libwrap0-dev,
  libwxgtk2.8-dev (>= 2.8.10), libvtk5-dev (>= 5.6.0), libinsighttoolkit3-dev (>= 3.20.0),
  libdcmtk2-dev (>= 3.6.0), libcairo2-dev (>= 1.8.10), 
  libgdcm2-dev, libwrap0, libfftw3-dev, chrpath, libsqlite3-dev,
  libmysqlclient-dev (>= 5.1.57)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/ginkgocadx/trunk/
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/ginkgocadx/trunk/
 Homepage: http://ginkgo-cadx.com/

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,11 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
+CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 
 %:
 	dh $@ --buildsystem=cmake --parallel
